#include <stdint.h>
#include <stdbool.h>
#ifndef __AHCC__
	#include <float.h>
#endif
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <tos.h>
#include <aes.h>
#include <vdi.h>

#define BALKENBREITE 50

typedef struct
{
	int16_t g_x;
	int16_t g_y;
	int16_t g_w;
	int16_t g_h;
} PGRECT;

int16_t ghandle, vhandle;
int16_t gwchar, ghchar, gwbox, ghbox;
int16_t work_in[44], work_out[56];
int16_t whandle, wf;
PGRECT work, deskxywh, deskredraw;
int16_t vpxyarray[7];

int16_t i;
char alw = 'A';
char lw[32];
#ifdef __AHCC__
	typedef struct laufwerkinfo{
		uint32_t gesamt;
		uint32_t frei;
		char text[255];
	} lwi;
#else
	typedef struct laufwerkinfo{
		double gesamt;
		double frei;
		char text[255];
	} lwi;
#endif

lwi laufwerk[32];

int16_t strmlen, zeilen;

DISKINFO phdfree = {0,0,0,0};

extern int16_t _app;

int16_t max(int16_t a, int16_t b){
	return a>b ? a : b;
}

int16_t min(int16_t a, int16_t b){
	return a<b ? a : b;
}

int16_t rc_intersect (PGRECT *p1, PGRECT *p2){
	int16_t tx, ty, tw, th;
	tw = min(p2->g_x + p2->g_w, p1->g_x + p1->g_w);
	th = min(p2->g_y + p2->g_h, p1->g_y + p1->g_h);
	tx = max(p2->g_x, p1->g_x);
	ty = max(p2->g_y, p1->g_y);
	p2->g_x = tx;
	p2->g_y = ty;
	p2->g_w = tw - tx;
	p2->g_h = th - ty;
	return ((tw > tx) && (th > ty));
}

int16_t vwk_oeffnen(void){
	ghandle = graf_handle(&gwchar, &ghchar, &gwbox, &ghbox);
	vhandle = ghandle;
	for(i=0; i<10; i++){
		work_in[i]=1;
	}
	work_in[10]=2;
	v_opnvwk(work_in, &vhandle, work_out);
	if(vhandle != 0){
		return true;
	}
	else{
		return false;
	}
}

int16_t fenster_erstellen(void){
	int16_t whandle;
	char titel[] = "HD Info";
	wind_get(0,WF_WORKXYWH, &deskxywh.g_x, &deskxywh.g_y, &deskxywh.g_w, &deskxywh.g_h);
	whandle = wind_create(NAME+CLOSER+FULLER+MOVER+SIZER, deskxywh.g_x, deskxywh.g_y, deskxywh.g_w, deskxywh.g_h);
	wind_set(whandle, WF_NAME, titel, 0, 0);
	return whandle;
}

void fenster_oeffnen(void){
	work.g_x = deskxywh.g_x;
	work.g_y = deskxywh.g_y;
	work.g_w = 100;
	work.g_h = 180;
	wind_calc(WC_BORDER, NAME+CLOSER+FULLER+MOVER+SIZER, work.g_x, work.g_y, strmlen*gwchar+BALKENBREITE+2, zeilen*ghbox, &deskredraw.g_x, &deskredraw.g_y, &deskredraw.g_w, &deskredraw.g_h);
	if(deskredraw.g_w < deskxywh.g_w){
		work.g_w = deskredraw.g_w;
	}
	if(deskredraw.g_h < deskxywh.g_h){
		work.g_h = deskredraw.g_h;
	}
	wind_open(whandle, work.g_x, work.g_y, work.g_w, work.g_h);
}

void hddinfo(void){
	uint16_t i;
	int32_t laufwerke;
	laufwerke = Drvmap();
	zeilen = 0;
	for(i=0;i<32;i++)
	{
		lw[i]=((laufwerke>>i)&1);
		if(lw[i] == 1)
		{
			if(Dfree(&phdfree, i+1) == 0)
			{
				#ifdef __AHCC__
					laufwerk[i].gesamt = ((((phdfree.b_secsiz>>8) * phdfree.b_clsiz) * phdfree.b_total)>>12);
					laufwerk[i].frei = ((((phdfree.b_secsiz>>8) * phdfree.b_clsiz) * phdfree.b_free)>>12);
					if((laufwerk[i].gesamt > 1024) && (laufwerk[i].frei > 1024)){
						sprintf(laufwerk[i].text, "%c: %ld GB (%ld%%) frei / %ld GB", alw+i, laufwerk[i].frei/1024, (laufwerk[i].frei*100/laufwerk[i].gesamt), laufwerk[i].gesamt/1024);
					}
					else if(laufwerk[i].gesamt > 1024){
						sprintf(laufwerk[i].text, "%c: %ld MB (%ld%%) frei / %ld GB", alw+i, laufwerk[i].frei, (laufwerk[i].frei*100/laufwerk[i].gesamt), laufwerk[i].gesamt/1024);
					}
					else{
						sprintf(laufwerk[i].text, "%c: %ld MB (%ld%%) frei / %ld MB", alw+i, laufwerk[i].frei, (laufwerk[i].frei*100/laufwerk[i].gesamt), laufwerk[i].gesamt);
					}
				#else
					laufwerk[i].gesamt = (double)( (double)( (double)( (double)( phdfree.b_clsiz * phdfree.b_secsiz) * phdfree.b_total) / 1024) / 1024);
					laufwerk[i].frei = (double)( (double)( (double)( (double)( phdfree.b_clsiz * phdfree.b_secsiz) * phdfree.b_free) / 1024) / 1024);
					if((laufwerk[i].gesamt > 1024) && (laufwerk[i].frei > 1024)){
						sprintf(laufwerk[i].text, "%c: %.2lf GB (%.2lf%%) frei / %.2lf GB", alw+i, (double) laufwerk[i].frei/1024, (laufwerk[i].frei*100/laufwerk[i].gesamt), (double) laufwerk[i].gesamt/1024);
					}
					else if(laufwerk[i].gesamt > 1024){
						sprintf(laufwerk[i].text, "%c: %.2lf MB (%.2lf%%) frei / %.2lf GB", alw+i, (double) laufwerk[i].frei, (laufwerk[i].frei*100/laufwerk[i].gesamt), (double) laufwerk[i].gesamt/1024);
					}
					else{
						sprintf(laufwerk[i].text, "%c: %.2lf MB (%.2lf%%) frei / %.2lf MB", alw+i, (double) laufwerk[i].frei, (laufwerk[i].frei*100/laufwerk[i].gesamt), (double) laufwerk[i].gesamt);
					}
				#endif
				strmlen = max((int16_t) strlen(laufwerk[i].text), strmlen);
				zeilen++;
			}
		}
	}
}

void events(int16_t *msg_buf, int16_t menu_id){
	int16_t zeile = 0;
	switch (msg_buf[0])
	{
		case AC_OPEN:
			if (msg_buf[4] == menu_id)
			{
				hddinfo();
				fenster_oeffnen();
			}
			break;
		case WM_REDRAW:
			wind_update(BEG_UPDATE);
			graf_mouse(M_OFF, 0);
			wind_get(msg_buf[3], WF_WORKXYWH, &work.g_x, &work.g_y, &work.g_w, &work.g_h);
			wind_get(msg_buf[3], WF_FIRSTXYWH, &deskredraw.g_x, &deskredraw.g_y, &deskredraw.g_w, &deskredraw.g_h);
			while(deskredraw.g_w | deskredraw.g_h){
				if(rc_intersect(&work, &deskredraw)){
					vpxyarray[0] = deskredraw.g_x;
					vpxyarray[1] = deskredraw.g_y;
					vpxyarray[2] = deskredraw.g_x+deskredraw.g_w-1;
					vpxyarray[3] = deskredraw.g_y+deskredraw.g_h-1;
					vst_color(vhandle, 1);		/* set graphic text color : schwarz */
					vswr_mode(vhandle, 2);		/* setting writing mode : transparent */
					vsf_interior(vhandle, 1);	/* flltyp : deckend */
					vsf_color(vhandle, 0);		/* fllfarbe : weiss */
					vs_clip(vhandle, 1, vpxyarray);
					v_bar(vhandle, vpxyarray);
					zeile = 0;
					for(i=2;i<32;i++)
					{
						if(lw[i] == 1)
						{
							if(zeile == 0){
								v_gtext(vhandle, work.g_x+1+BALKENBREITE, work.g_y+(ghbox/2)+2+(zeile*ghbox)+1, laufwerk[i].text);
								vsf_interior(vhandle, 0);	/* flltyp : leer */
								vsf_color(vhandle, 1);		/* fllfarbe : schwarz */
								vpxyarray[0] = work.g_x+1;
								vpxyarray[1] = work.g_y+1;
								vpxyarray[2] = work.g_x+BALKENBREITE;
								vpxyarray[3] = work.g_y+ghbox-(ghbox/2)+1;
								v_bar(vhandle, vpxyarray);
								vsf_interior(vhandle, 2);	/* flltyp : muster */
								vsf_style(vhandle, 4);		/* muster : 4 */
								vsf_color(vhandle, 1);		/* fllfarbe : schwarz */
								vpxyarray[0] = work.g_x+1;
								vpxyarray[1] = work.g_y+1;
								vpxyarray[2] = work.g_x+(BALKENBREITE-(laufwerk[i].frei*100/laufwerk[i].gesamt)/2);
								vpxyarray[3] = work.g_y+ghbox-(ghbox/2)+1;
								v_bar(vhandle, vpxyarray);
							}
							else{
								v_gtext(vhandle, work.g_x+1+BALKENBREITE, work.g_y+(ghbox/2)+1+(zeile*ghbox)+1, laufwerk[i].text);
								vsf_interior(vhandle, 0);	/* flltyp : leer */
								vsf_color(vhandle, 1);		/* fllfarbe : schwarz */
								vpxyarray[0] = work.g_x+1;
								vpxyarray[1] = work.g_y+(zeile*ghbox);
								vpxyarray[2] = work.g_x+BALKENBREITE;
								vpxyarray[3] = work.g_y+ghbox-(ghbox/2)+(zeile*ghbox);
								v_bar(vhandle, vpxyarray);
								vsf_interior(vhandle, 2);	/* flltyp : muster */
								vsf_style(vhandle, 4);		/* muster : 4 */
								vsf_color(vhandle, 1);		/* fllfarbe : schwarz */
								vpxyarray[0] = work.g_x+1;
								vpxyarray[1] = work.g_y+(zeile*ghbox);
								vpxyarray[2] = work.g_x+(BALKENBREITE-(laufwerk[i].frei*100/laufwerk[i].gesamt)/2);
								vpxyarray[3] = work.g_y+ghbox-(ghbox/2)+(zeile*ghbox);
								v_bar(vhandle, vpxyarray);
							}
							zeile = zeile + 1;
						}
					}
					vs_clip(vhandle, 0, vpxyarray);
				}
				wind_get(msg_buf[3], WF_NEXTXYWH, &deskredraw.g_x, &deskredraw.g_y, &deskredraw.g_w, &deskredraw.g_h);
			}
			graf_mouse(M_ON, 0);
			wind_update(END_UPDATE);
			break;
		case WM_TOPPED:
			wind_set(msg_buf[3], WF_TOP, msg_buf[4], msg_buf[5], msg_buf[6], msg_buf[7]);
			break;
		case AC_CLOSE:
		case WM_CLOSED:
		case AP_TERM:
			wind_close(msg_buf[3]);
			if(_app == 1){
				v_clsvwk(vhandle);
				appl_exit();
			}
			break;
		case WM_FULLED:
			if(wf == 0){
				wf = 1;
				wind_get(msg_buf[3], WF_FULLXYWH, &work.g_x, &work.g_y, &work.g_w, &work.g_h);
			}
			else{
				wf = 0;
				wind_get(msg_buf[3], WF_PREVXYWH, &work.g_x, &work.g_y, &work.g_w, &work.g_h);
			}
			wind_set(msg_buf[3], WF_CURRXYWH, work.g_x, work.g_y, work.g_w, work.g_h);
			break;
		case WM_SIZED:
		case WM_MOVED:
			wind_set(msg_buf[3], WF_CURRXYWH, msg_buf[4], msg_buf[5], msg_buf[6], msg_buf[7]);
			break;
	}
}

void main(void){
	char acc_name[] = "  HD Info...";
	int16_t ap_id, menu_id = 0;
	int16_t msg_buf[8];
	
	ap_id = appl_init();
	
	if (ap_id >= 0)
	{
		if(vwk_oeffnen()){
			if(_app == 0){
				menu_id = menu_register(ap_id, acc_name);
			}
			if ((menu_id >= 0) | (_app == 1))
			{
				whandle = fenster_erstellen();
				if(_app == 1){
					hddinfo();
					fenster_oeffnen();
				}
				while(true)
				{
					evnt_mesag(msg_buf);
					events(msg_buf, menu_id);
				}
			}
		}
	}
	if(_app == 0){
		for(;;) evnt_mesag (msg_buf);
	}
	else{
		appl_exit();
	}
}

